import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author Tomasz Lubinski
 * (c)2005 algorytm.org
 *
 *  EAN8 Bar Code
 */
public class EAN8 implements ActionListener {

	private BarCode barCode = new BarCode(); 
	
    JFrame mainFrame;
    JPanel mainPanel;
    JPanel inputPanel;
    
    JTextField inputValue;
    JButton generateButton;
    JBarCode outputBars;
    
	public EAN8() {
		mainFrame = new JFrame("Generate EAN8 Bar Code");
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		//create and set all components
		inputPanel = new JPanel();
		inputValue = new JTextField("55123457");
    	generateButton = new JButton("Generate");
    	inputPanel.add(inputValue);
    	inputPanel.add(generateButton);
    	
    	outputBars = new JBarCode();

        //Listen to events from the generate button.
    	inputValue.addActionListener(this);
    	generateButton.addActionListener(this);
    	
        //Create the main panel
		mainPanel = new JPanel(new GridLayout(1, 2));
    	mainPanel.add(inputPanel);
    	mainPanel.add(outputBars);
    	
        mainFrame.getContentPane().add(mainPanel, BorderLayout.CENTER);
        mainFrame.setSize(470, 150);
		mainFrame.setVisible(true);
	}
	
   
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        EAN8 ean8 = new EAN8();
    }
    
	public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });		
	}

	public void actionPerformed(ActionEvent arg0) {
		byte input[] = new byte[8];
		byte result[] = null;
		String code = inputValue.getText();
			
		try
		{
			if (code.length() == 8) {
				for (int i=0; i<8; i++) {
					input[i] = Byte.parseByte(code.substring(i, i+1));
				}
				result = barCode.convert(input);
			}
		} catch (Exception e) {
			result = null;
		}
		
		if (result != null) {
			outputBars.setBars(result, code);
			outputBars.repaint();
		} 
		else {
			JOptionPane.showMessageDialog(mainFrame, "Incorrect input number");
		}
	}
}
