import java.awt.*;

public class JBarCode extends Component {

	final static Color white = Color.white;
    final static Color black = Color.black;
    
    private byte bars[];
    private String EAN8;

    public void setBars(byte input[], String code){
    	bars = input;
    	EAN8 = code;
    }
    
	public void paint(Graphics g) {
		int length;
		Dimension d = getSize();
        Graphics2D g2 = (Graphics2D) g;
        
        g2.setPaint(white);
        g2.fillRect(0, 0, d.width-1, d.height-1);
        
        g2.setFont(new Font("Arial", 0, 10));
        g2.setPaint(black);
        if (bars != null) {
        	for (int i=0; i<bars.length; i++) {
                if ((i >= 0 && i<= 2) ||
                    (i >= 31 && i<= 35) ||
                    (i >= 64 && i<= 66)) {
                        length = 100;
                    } else {
                        length = 90;
                    }        		
        		if (bars[i] == 1) {
        			g2.fillRect(i*2+20, 10, 2, length);
        		}
        	}
        	for (int i=0; i<4; i++) {
        		g2.drawString(EAN8.substring(i, i+1), i*14+31, 110);
        	}
        	for (int i=4; i<8; i++) {
        		g2.drawString(EAN8.substring(i, i+1), i*14+41, 110);
        	}        	
        }
    }
}
